/* Sidebar.c generated by valac 0.56.17, the Vala compiler
 * generated from Sidebar.vala, do not modify */

/*
 * Copyright 2011-2023 elementary, Inc (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "notifications.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <adwaita.h>
#include <granite-7.h>
#include <gee.h>

#define WIDGETS_SIDEBAR_FALLBACK_APP_ID "gala-other.desktop"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_SIDEBAR_0_PROPERTY,
	WIDGETS_SIDEBAR_NUM_PROPERTIES
};
static GParamSpec* widgets_sidebar_properties[WIDGETS_SIDEBAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;

struct _WidgetsSidebarPrivate {
	GtkSearchEntry* search_entry;
};

struct _Block1Data {
	int _ref_count_;
	WidgetsSidebar* self;
	GtkRevealer* search_revealer;
	GtkListBox* app_list;
};

static gint WidgetsSidebar_private_offset;
static gpointer widgets_sidebar_parent_class = NULL;

static gboolean widgets_sidebar_filter_function (WidgetsSidebar* self,
                                          GtkListBoxRow* row);
static gint widgets_sidebar_sort_func (WidgetsSidebar* self,
                                GtkListBoxRow* row1,
                                GtkListBoxRow* row2);
static void widgets_sidebar_show_row (WidgetsSidebar* self,
                               GtkListBoxRow* row);
static GObject * widgets_sidebar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _widgets_sidebar_filter_function_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                    gpointer self);
static gint _widgets_sidebar_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2,
                                                        gpointer self);
static void _widgets_sidebar_show_row_gtk_list_box_row_selected (GtkListBox* _sender,
                                                          GtkListBoxRow* row,
                                                          gpointer self);
static void _widgets_sidebar___lambda5_ (Block1Data* _data1_);
static void __widgets_sidebar___lambda5__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                   gpointer self);
static void _widgets_sidebar___lambda6_ (Block1Data* _data1_);
static void __widgets_sidebar___lambda6__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static gboolean _widgets_sidebar___lambda7_ (Block1Data* _data1_,
                                      GeeMapEntry* entry);
static gboolean __widgets_sidebar___lambda7__gee_forall_func (gpointer g,
                                                       gpointer self);
static void widgets_sidebar_finalize (GObject * obj);
static GType widgets_sidebar_get_type_once (void);

static inline gpointer
widgets_sidebar_get_instance_private (WidgetsSidebar* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsSidebar_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 126 "Sidebar.c"
}

static gboolean
widgets_sidebar_filter_function (WidgetsSidebar* self,
                                 GtkListBoxRow* row)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 127 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 128 "../src/Widgets/Sidebar.vala"
	_tmp0_ = self->priv->search_entry;
#line 128 "../src/Widgets/Sidebar.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 128 "../src/Widgets/Sidebar.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/Widgets/Sidebar.vala"
	if (g_strcmp0 (_tmp2_, "") != 0) {
#line 149 "Sidebar.c"
		gchar* search_term = NULL;
		GtkSearchEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* row_name = NULL;
		BackendApp* _tmp7_;
		BackendApp* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		GDesktopAppInfo* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 129 "../src/Widgets/Sidebar.vala"
		_tmp3_ = self->priv->search_entry;
#line 129 "../src/Widgets/Sidebar.vala"
		_tmp4_ = gtk_editable_get_text ((GtkEditable*) _tmp3_);
#line 129 "../src/Widgets/Sidebar.vala"
		_tmp5_ = _tmp4_;
#line 129 "../src/Widgets/Sidebar.vala"
		_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
#line 129 "../src/Widgets/Sidebar.vala"
		search_term = _tmp6_;
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp7_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp8_ = _tmp7_;
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp9_ = backend_app_get_app_info (_tmp8_);
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp10_ = _tmp9_;
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp11_ = g_app_info_get_display_name ((GAppInfo*) _tmp10_);
#line 130 "../src/Widgets/Sidebar.vala"
		_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 130 "../src/Widgets/Sidebar.vala"
		row_name = _tmp12_;
#line 132 "../src/Widgets/Sidebar.vala"
		_tmp13_ = row_name;
#line 132 "../src/Widgets/Sidebar.vala"
		_tmp14_ = search_term;
#line 132 "../src/Widgets/Sidebar.vala"
		result = string_contains (_tmp13_, _tmp14_);
#line 132 "../src/Widgets/Sidebar.vala"
		_g_free0 (row_name);
#line 132 "../src/Widgets/Sidebar.vala"
		_g_free0 (search_term);
#line 132 "../src/Widgets/Sidebar.vala"
		return result;
#line 200 "Sidebar.c"
	}
#line 135 "../src/Widgets/Sidebar.vala"
	result = TRUE;
#line 135 "../src/Widgets/Sidebar.vala"
	return result;
#line 206 "Sidebar.c"
}

static gint
widgets_sidebar_sort_func (WidgetsSidebar* self,
                           GtkListBoxRow* row1,
                           GtkListBoxRow* row2)
{
	gboolean _tmp0_ = FALSE;
	BackendApp* _tmp1_;
	BackendApp* _tmp2_;
	GDesktopAppInfo* _tmp3_;
	GDesktopAppInfo* _tmp4_;
	const gchar* _tmp5_;
	gchar* row_name1 = NULL;
	BackendApp* _tmp11_;
	BackendApp* _tmp12_;
	GDesktopAppInfo* _tmp13_;
	GDesktopAppInfo* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* row_name2 = NULL;
	BackendApp* _tmp17_;
	BackendApp* _tmp18_;
	GDesktopAppInfo* _tmp19_;
	GDesktopAppInfo* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gint order = 0;
	GCompareFunc _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gint result;
#line 138 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 138 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 138 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 139 "../src/Widgets/Sidebar.vala"
	if (WIDGETS_IS_APP_ENTRY (row1)) {
#line 139 "../src/Widgets/Sidebar.vala"
		_tmp0_ = WIDGETS_IS_APP_ENTRY (row2);
#line 249 "Sidebar.c"
	} else {
#line 139 "../src/Widgets/Sidebar.vala"
		_tmp0_ = FALSE;
#line 253 "Sidebar.c"
	}
#line 139 "../src/Widgets/Sidebar.vala"
	if (!_tmp0_) {
#line 140 "../src/Widgets/Sidebar.vala"
		result = 0;
#line 140 "../src/Widgets/Sidebar.vala"
		return result;
#line 261 "Sidebar.c"
	}
#line 143 "../src/Widgets/Sidebar.vala"
	_tmp1_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row1, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 143 "../src/Widgets/Sidebar.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/Widgets/Sidebar.vala"
	_tmp3_ = backend_app_get_app_info (_tmp2_);
#line 143 "../src/Widgets/Sidebar.vala"
	_tmp4_ = _tmp3_;
#line 143 "../src/Widgets/Sidebar.vala"
	_tmp5_ = g_app_info_get_id ((GAppInfo*) _tmp4_);
#line 143 "../src/Widgets/Sidebar.vala"
	if (g_strcmp0 (_tmp5_, WIDGETS_SIDEBAR_FALLBACK_APP_ID) == 0) {
#line 144 "../src/Widgets/Sidebar.vala"
		result = 1;
#line 144 "../src/Widgets/Sidebar.vala"
		return result;
#line 279 "Sidebar.c"
	} else {
		BackendApp* _tmp6_;
		BackendApp* _tmp7_;
		GDesktopAppInfo* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		const gchar* _tmp10_;
#line 145 "../src/Widgets/Sidebar.vala"
		_tmp6_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row2, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 145 "../src/Widgets/Sidebar.vala"
		_tmp7_ = _tmp6_;
#line 145 "../src/Widgets/Sidebar.vala"
		_tmp8_ = backend_app_get_app_info (_tmp7_);
#line 145 "../src/Widgets/Sidebar.vala"
		_tmp9_ = _tmp8_;
#line 145 "../src/Widgets/Sidebar.vala"
		_tmp10_ = g_app_info_get_id ((GAppInfo*) _tmp9_);
#line 145 "../src/Widgets/Sidebar.vala"
		if (g_strcmp0 (_tmp10_, WIDGETS_SIDEBAR_FALLBACK_APP_ID) == 0) {
#line 146 "../src/Widgets/Sidebar.vala"
			result = -1;
#line 146 "../src/Widgets/Sidebar.vala"
			return result;
#line 302 "Sidebar.c"
		}
	}
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp11_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row1, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp12_ = _tmp11_;
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp13_ = backend_app_get_app_info (_tmp12_);
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp14_ = _tmp13_;
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp15_ = g_app_info_get_display_name ((GAppInfo*) _tmp14_);
#line 149 "../src/Widgets/Sidebar.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 149 "../src/Widgets/Sidebar.vala"
	row_name1 = _tmp16_;
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp17_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row2, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp18_ = _tmp17_;
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp19_ = backend_app_get_app_info (_tmp18_);
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp20_ = _tmp19_;
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp21_ = g_app_info_get_display_name ((GAppInfo*) _tmp20_);
#line 150 "../src/Widgets/Sidebar.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 150 "../src/Widgets/Sidebar.vala"
	row_name2 = _tmp22_;
#line 152 "../src/Widgets/Sidebar.vala"
	_tmp23_ = ((GCompareFunc) g_strcmp0);
#line 152 "../src/Widgets/Sidebar.vala"
	_tmp24_ = row_name1;
#line 152 "../src/Widgets/Sidebar.vala"
	_tmp25_ = row_name2;
#line 152 "../src/Widgets/Sidebar.vala"
	order = _tmp23_ (_tmp24_, _tmp25_);
#line 154 "../src/Widgets/Sidebar.vala"
	result = CLAMP (order, -1, 1);
#line 154 "../src/Widgets/Sidebar.vala"
	_g_free0 (row_name2);
#line 154 "../src/Widgets/Sidebar.vala"
	_g_free0 (row_name1);
#line 154 "../src/Widgets/Sidebar.vala"
	return result;
#line 349 "Sidebar.c"
}

static void
widgets_sidebar_show_row (WidgetsSidebar* self,
                          GtkListBoxRow* row)
{
	gboolean _tmp0_ = FALSE;
	BackendNotifyManager* _tmp1_;
	BackendApp* _tmp2_;
	BackendApp* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 157 "../src/Widgets/Sidebar.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/Widgets/Sidebar.vala"
	if (row == NULL) {
#line 158 "../src/Widgets/Sidebar.vala"
		_tmp0_ = TRUE;
#line 368 "Sidebar.c"
	} else {
#line 158 "../src/Widgets/Sidebar.vala"
		_tmp0_ = !WIDGETS_IS_APP_ENTRY (row);
#line 372 "Sidebar.c"
	}
#line 158 "../src/Widgets/Sidebar.vala"
	if (_tmp0_) {
#line 159 "../src/Widgets/Sidebar.vala"
		return;
#line 378 "Sidebar.c"
	}
#line 162 "../src/Widgets/Sidebar.vala"
	_tmp1_ = backend_notify_manager_get_default ();
#line 162 "../src/Widgets/Sidebar.vala"
	_tmp2_ = widgets_app_entry_get_app (G_TYPE_CHECK_INSTANCE_CAST (row, WIDGETS_TYPE_APP_ENTRY, WidgetsAppEntry));
#line 162 "../src/Widgets/Sidebar.vala"
	_tmp3_ = _tmp2_;
#line 162 "../src/Widgets/Sidebar.vala"
	_tmp4_ = backend_app_get_app_id (_tmp3_);
#line 162 "../src/Widgets/Sidebar.vala"
	_tmp5_ = _tmp4_;
#line 162 "../src/Widgets/Sidebar.vala"
	backend_notify_manager_set_selected_app_id (_tmp1_, _tmp5_);
#line 392 "Sidebar.c"
}

WidgetsSidebar*
widgets_sidebar_construct (GType object_type)
{
	WidgetsSidebar * self = NULL;
#line 20 "../src/Widgets/Sidebar.vala"
	self = (WidgetsSidebar*) g_object_new (object_type, NULL);
#line 20 "../src/Widgets/Sidebar.vala"
	return self;
#line 403 "Sidebar.c"
}

WidgetsSidebar*
widgets_sidebar_new (void)
{
#line 20 "../src/Widgets/Sidebar.vala"
	return widgets_sidebar_construct (WIDGETS_TYPE_SIDEBAR);
#line 411 "Sidebar.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 29 "../src/Widgets/Sidebar.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 29 "../src/Widgets/Sidebar.vala"
	return _data1_;
#line 421 "Sidebar.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 29 "../src/Widgets/Sidebar.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 431 "Sidebar.c"
		WidgetsSidebar* self;
#line 29 "../src/Widgets/Sidebar.vala"
		self = _data1_->self;
#line 29 "../src/Widgets/Sidebar.vala"
		_g_object_unref0 (_data1_->app_list);
#line 29 "../src/Widgets/Sidebar.vala"
		_g_object_unref0 (_data1_->search_revealer);
#line 29 "../src/Widgets/Sidebar.vala"
		_g_object_unref0 (self);
#line 29 "../src/Widgets/Sidebar.vala"
		g_slice_free (Block1Data, _data1_);
#line 443 "Sidebar.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/Widgets/Sidebar.vala"
	return self ? g_object_ref (self) : NULL;
#line 452 "Sidebar.c"
}

static gboolean
_widgets_sidebar_filter_function_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                           gpointer self)
{
	gboolean result;
	result = widgets_sidebar_filter_function ((WidgetsSidebar*) self, row);
#line 59 "../src/Widgets/Sidebar.vala"
	return result;
#line 463 "Sidebar.c"
}

static gint
_widgets_sidebar_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                   GtkListBoxRow* row2,
                                                   gpointer self)
{
	gint result;
	result = widgets_sidebar_sort_func ((WidgetsSidebar*) self, row1, row2);
#line 60 "../src/Widgets/Sidebar.vala"
	return result;
#line 475 "Sidebar.c"
}

static void
_widgets_sidebar_show_row_gtk_list_box_row_selected (GtkListBox* _sender,
                                                     GtkListBoxRow* row,
                                                     gpointer self)
{
#line 89 "../src/Widgets/Sidebar.vala"
	widgets_sidebar_show_row ((WidgetsSidebar*) self, row);
#line 485 "Sidebar.c"
}

static void
_widgets_sidebar___lambda5_ (Block1Data* _data1_)
{
	WidgetsSidebar* self;
	GtkListBox* _tmp0_;
#line 91 "../src/Widgets/Sidebar.vala"
	self = _data1_->self;
#line 92 "../src/Widgets/Sidebar.vala"
	_tmp0_ = _data1_->app_list;
#line 92 "../src/Widgets/Sidebar.vala"
	gtk_list_box_invalidate_filter (_tmp0_);
#line 499 "Sidebar.c"
}

static void
__widgets_sidebar___lambda5__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                              gpointer self)
{
#line 91 "../src/Widgets/Sidebar.vala"
	_widgets_sidebar___lambda5_ (self);
#line 508 "Sidebar.c"
}

static void
_widgets_sidebar___lambda6_ (Block1Data* _data1_)
{
	WidgetsSidebar* self;
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 97 "../src/Widgets/Sidebar.vala"
	self = _data1_->self;
#line 98 "../src/Widgets/Sidebar.vala"
	_tmp0_ = _data1_->search_revealer;
#line 98 "../src/Widgets/Sidebar.vala"
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
#line 98 "../src/Widgets/Sidebar.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/Widgets/Sidebar.vala"
	if (_tmp2_) {
#line 528 "Sidebar.c"
		GtkSearchEntry* _tmp3_;
#line 99 "../src/Widgets/Sidebar.vala"
		_tmp3_ = self->priv->search_entry;
#line 99 "../src/Widgets/Sidebar.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 534 "Sidebar.c"
	} else {
		GtkSearchEntry* _tmp4_;
#line 101 "../src/Widgets/Sidebar.vala"
		_tmp4_ = self->priv->search_entry;
#line 101 "../src/Widgets/Sidebar.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp4_, "");
#line 541 "Sidebar.c"
	}
}

static void
__widgets_sidebar___lambda6__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 97 "../src/Widgets/Sidebar.vala"
	_widgets_sidebar___lambda6_ (self);
#line 552 "Sidebar.c"
}

static gboolean
_widgets_sidebar___lambda7_ (Block1Data* _data1_,
                             GeeMapEntry* entry)
{
	WidgetsSidebar* self;
	WidgetsAppEntry* app_entry = NULL;
	gconstpointer _tmp0_;
	gconstpointer _tmp1_;
	WidgetsAppEntry* _tmp2_;
	GtkListBox* _tmp3_;
	WidgetsAppEntry* _tmp4_;
	gboolean result;
#line 112 "../src/Widgets/Sidebar.vala"
	self = _data1_->self;
#line 112 "../src/Widgets/Sidebar.vala"
	g_return_val_if_fail (entry != NULL, FALSE);
#line 113 "../src/Widgets/Sidebar.vala"
	_tmp0_ = gee_map_entry_get_value (entry);
#line 113 "../src/Widgets/Sidebar.vala"
	_tmp1_ = _tmp0_;
#line 113 "../src/Widgets/Sidebar.vala"
	_tmp2_ = widgets_app_entry_new ((BackendApp*) _tmp1_);
#line 113 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp2_);
#line 113 "../src/Widgets/Sidebar.vala"
	app_entry = _tmp2_;
#line 114 "../src/Widgets/Sidebar.vala"
	_tmp3_ = _data1_->app_list;
#line 114 "../src/Widgets/Sidebar.vala"
	_tmp4_ = app_entry;
#line 114 "../src/Widgets/Sidebar.vala"
	gtk_list_box_append (_tmp3_, (GtkWidget*) _tmp4_);
#line 116 "../src/Widgets/Sidebar.vala"
	result = TRUE;
#line 116 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (app_entry);
#line 116 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (entry);
#line 116 "../src/Widgets/Sidebar.vala"
	return result;
#line 595 "Sidebar.c"
}

static gboolean
__widgets_sidebar___lambda7__gee_forall_func (gpointer g,
                                              gpointer self)
{
	gboolean result;
	result = _widgets_sidebar___lambda7_ (self, (GeeMapEntry*) g);
#line 112 "../src/Widgets/Sidebar.vala"
	return result;
#line 606 "Sidebar.c"
}

static GObject *
widgets_sidebar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsSidebar * self;
	Block1Data* _data1_;
	gchar* _tmp0_;
	GtkSearchEntry* _tmp1_ = NULL;
	GtkSearchEntry* _tmp2_;
	GtkWidget* _tmp3_;
	GtkRevealer* _tmp4_ = NULL;
	GtkToggleButton* search_toggle = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkToggleButton* _tmp7_ = NULL;
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp8_ = NULL;
	AdwHeaderBar* _tmp9_;
	GtkToggleButton* _tmp10_;
	GtkListBox* _tmp11_ = NULL;
	GtkListBox* _tmp12_;
	GtkListBox* _tmp13_;
	GtkScrolledWindow* scrolled_window = NULL;
	GtkListBox* _tmp14_;
	GtkWidget* _tmp15_;
	GtkScrolledWindow* _tmp16_ = NULL;
	GtkLabel* do_not_disturb_label = NULL;
	GtkLabel* _tmp17_;
	GtkSwitch* do_not_disturb_switch = NULL;
	GtkSwitch* _tmp18_ = NULL;
	GtkActionBar* footer = NULL;
	GtkActionBar* _tmp19_;
	GtkActionBar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkActionBar* _tmp22_;
	GtkSwitch* _tmp23_;
	AdwToolbarView* toolbarview = NULL;
	GtkScrolledWindow* _tmp24_;
	GtkWidget* _tmp25_;
	AdwToolbarView* _tmp26_ = NULL;
	AdwToolbarView* _tmp27_;
	AdwHeaderBar* _tmp28_;
	AdwToolbarView* _tmp29_;
	GtkRevealer* _tmp30_;
	AdwToolbarView* _tmp31_;
	GtkActionBar* _tmp32_;
	AdwToolbarView* _tmp33_;
	GtkListBox* _tmp34_;
	GtkSearchEntry* _tmp35_;
	GtkToggleButton* _tmp36_;
	GtkRevealer* _tmp37_;
	GtkRevealer* _tmp38_;
	GSettings* _tmp39_;
	GtkSwitch* _tmp40_;
	BackendNotifyManager* _tmp41_;
	GeeHashMap* _tmp42_;
	GeeHashMap* _tmp43_;
	GtkListBox* _tmp44_;
	GtkWidget* _tmp45_;
#line 29 "../src/Widgets/Sidebar.vala"
	parent_class = G_OBJECT_CLASS (widgets_sidebar_parent_class);
#line 29 "../src/Widgets/Sidebar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 29 "../src/Widgets/Sidebar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SIDEBAR, WidgetsSidebar);
#line 29 "../src/Widgets/Sidebar.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 29 "../src/Widgets/Sidebar.vala"
	_data1_->_ref_count_ = 1;
#line 29 "../src/Widgets/Sidebar.vala"
	_data1_->self = g_object_ref (self);
#line 30 "../src/Widgets/Sidebar.vala"
	_tmp0_ = g_strdup (_ ("Search Apps"));
#line 30 "../src/Widgets/Sidebar.vala"
	_tmp1_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 30 "../src/Widgets/Sidebar.vala"
	g_object_set (_tmp1_, "placeholder-text", _tmp0_, NULL);
#line 30 "../src/Widgets/Sidebar.vala"
	_g_free0 (_tmp0_);
#line 30 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 6);
#line 30 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 6);
#line 30 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 6);
#line 30 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, 6);
#line 30 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 30 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp1_);
#line 30 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 30 "../src/Widgets/Sidebar.vala"
	self->priv->search_entry = _tmp1_;
#line 39 "../src/Widgets/Sidebar.vala"
	_tmp2_ = self->priv->search_entry;
#line 39 "../src/Widgets/Sidebar.vala"
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
#line 39 "../src/Widgets/Sidebar.vala"
	_tmp4_ = (GtkRevealer*) gtk_revealer_new ();
#line 39 "../src/Widgets/Sidebar.vala"
	gtk_revealer_set_child (_tmp4_, _tmp3_);
#line 39 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (_tmp3_);
#line 39 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp4_);
#line 39 "../src/Widgets/Sidebar.vala"
	_data1_->search_revealer = _tmp4_;
#line 43 "../src/Widgets/Sidebar.vala"
	_tmp5_ = g_strdup ("edit-find-symbolic");
#line 43 "../src/Widgets/Sidebar.vala"
	_tmp6_ = g_strdup (_ ("Search Apps"));
#line 43 "../src/Widgets/Sidebar.vala"
	_tmp7_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 43 "../src/Widgets/Sidebar.vala"
	gtk_button_set_icon_name ((GtkButton*) _tmp7_, _tmp5_);
#line 43 "../src/Widgets/Sidebar.vala"
	_g_free0 (_tmp5_);
#line 43 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _tmp6_);
#line 43 "../src/Widgets/Sidebar.vala"
	_g_free0 (_tmp6_);
#line 43 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp7_);
#line 43 "../src/Widgets/Sidebar.vala"
	search_toggle = _tmp7_;
#line 48 "../src/Widgets/Sidebar.vala"
	_tmp8_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 48 "../src/Widgets/Sidebar.vala"
	adw_header_bar_set_show_end_title_buttons (_tmp8_, FALSE);
#line 48 "../src/Widgets/Sidebar.vala"
	adw_header_bar_set_show_title (_tmp8_, FALSE);
#line 48 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp8_);
#line 48 "../src/Widgets/Sidebar.vala"
	headerbar = _tmp8_;
#line 52 "../src/Widgets/Sidebar.vala"
	_tmp9_ = headerbar;
#line 52 "../src/Widgets/Sidebar.vala"
	_tmp10_ = search_toggle;
#line 52 "../src/Widgets/Sidebar.vala"
	adw_header_bar_pack_end (_tmp9_, (GtkWidget*) _tmp10_);
#line 54 "../src/Widgets/Sidebar.vala"
	_tmp11_ = (GtkListBox*) gtk_list_box_new ();
#line 54 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 54 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
#line 54 "../src/Widgets/Sidebar.vala"
	gtk_list_box_set_selection_mode (_tmp11_, GTK_SELECTION_SINGLE);
#line 54 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp11_);
#line 54 "../src/Widgets/Sidebar.vala"
	_data1_->app_list = _tmp11_;
#line 59 "../src/Widgets/Sidebar.vala"
	_tmp12_ = _data1_->app_list;
#line 59 "../src/Widgets/Sidebar.vala"
	gtk_list_box_set_filter_func (_tmp12_, _widgets_sidebar_filter_function_gtk_list_box_filter_func, g_object_ref (self), g_object_unref);
#line 60 "../src/Widgets/Sidebar.vala"
	_tmp13_ = _data1_->app_list;
#line 60 "../src/Widgets/Sidebar.vala"
	gtk_list_box_set_sort_func (_tmp13_, _widgets_sidebar_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 62 "../src/Widgets/Sidebar.vala"
	_tmp14_ = _data1_->app_list;
#line 62 "../src/Widgets/Sidebar.vala"
	_tmp15_ = _g_object_ref0 ((GtkWidget*) _tmp14_);
#line 62 "../src/Widgets/Sidebar.vala"
	_tmp16_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 62 "../src/Widgets/Sidebar.vala"
	gtk_scrolled_window_set_child (_tmp16_, _tmp15_);
#line 62 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (_tmp15_);
#line 62 "../src/Widgets/Sidebar.vala"
	g_object_set (_tmp16_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 62 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp16_);
#line 62 "../src/Widgets/Sidebar.vala"
	scrolled_window = _tmp16_;
#line 67 "../src/Widgets/Sidebar.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (_ ("Do Not Disturb"));
#line 67 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp17_);
#line 67 "../src/Widgets/Sidebar.vala"
	do_not_disturb_label = _tmp17_;
#line 69 "../src/Widgets/Sidebar.vala"
	_tmp18_ = (GtkSwitch*) gtk_switch_new ();
#line 69 "../src/Widgets/Sidebar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 69 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp18_);
#line 69 "../src/Widgets/Sidebar.vala"
	do_not_disturb_switch = _tmp18_;
#line 73 "../src/Widgets/Sidebar.vala"
	_tmp19_ = (GtkActionBar*) gtk_action_bar_new ();
#line 73 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp19_);
#line 73 "../src/Widgets/Sidebar.vala"
	footer = _tmp19_;
#line 74 "../src/Widgets/Sidebar.vala"
	_tmp20_ = footer;
#line 74 "../src/Widgets/Sidebar.vala"
	_tmp21_ = do_not_disturb_label;
#line 74 "../src/Widgets/Sidebar.vala"
	gtk_action_bar_pack_start (_tmp20_, (GtkWidget*) _tmp21_);
#line 75 "../src/Widgets/Sidebar.vala"
	_tmp22_ = footer;
#line 75 "../src/Widgets/Sidebar.vala"
	_tmp23_ = do_not_disturb_switch;
#line 75 "../src/Widgets/Sidebar.vala"
	gtk_action_bar_pack_end (_tmp22_, (GtkWidget*) _tmp23_);
#line 77 "../src/Widgets/Sidebar.vala"
	_tmp24_ = scrolled_window;
#line 77 "../src/Widgets/Sidebar.vala"
	_tmp25_ = _g_object_ref0 ((GtkWidget*) _tmp24_);
#line 77 "../src/Widgets/Sidebar.vala"
	_tmp26_ = (AdwToolbarView*) adw_toolbar_view_new ();
#line 77 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_set_content (_tmp26_, _tmp25_);
#line 77 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (_tmp25_);
#line 77 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_set_top_bar_style (_tmp26_, ADW_TOOLBAR_FLAT);
#line 77 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_set_bottom_bar_style (_tmp26_, ADW_TOOLBAR_RAISED);
#line 77 "../src/Widgets/Sidebar.vala"
	g_object_ref_sink (_tmp26_);
#line 77 "../src/Widgets/Sidebar.vala"
	toolbarview = _tmp26_;
#line 82 "../src/Widgets/Sidebar.vala"
	_tmp27_ = toolbarview;
#line 82 "../src/Widgets/Sidebar.vala"
	_tmp28_ = headerbar;
#line 82 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_add_top_bar (_tmp27_, (GtkWidget*) _tmp28_);
#line 83 "../src/Widgets/Sidebar.vala"
	_tmp29_ = toolbarview;
#line 83 "../src/Widgets/Sidebar.vala"
	_tmp30_ = _data1_->search_revealer;
#line 83 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_add_top_bar (_tmp29_, (GtkWidget*) _tmp30_);
#line 84 "../src/Widgets/Sidebar.vala"
	_tmp31_ = toolbarview;
#line 84 "../src/Widgets/Sidebar.vala"
	_tmp32_ = footer;
#line 84 "../src/Widgets/Sidebar.vala"
	adw_toolbar_view_add_bottom_bar (_tmp31_, (GtkWidget*) _tmp32_);
#line 86 "../src/Widgets/Sidebar.vala"
	_tmp33_ = toolbarview;
#line 86 "../src/Widgets/Sidebar.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp33_);
#line 87 "../src/Widgets/Sidebar.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, GRANITE_STYLE_CLASS_SIDEBAR);
#line 89 "../src/Widgets/Sidebar.vala"
	_tmp34_ = _data1_->app_list;
#line 89 "../src/Widgets/Sidebar.vala"
	g_signal_connect_object (_tmp34_, "row-selected", (GCallback) _widgets_sidebar_show_row_gtk_list_box_row_selected, self, 0);
#line 91 "../src/Widgets/Sidebar.vala"
	_tmp35_ = self->priv->search_entry;
#line 91 "../src/Widgets/Sidebar.vala"
	g_signal_connect_data (_tmp35_, "search-changed", (GCallback) __widgets_sidebar___lambda5__gtk_search_entry_search_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 95 "../src/Widgets/Sidebar.vala"
	_tmp36_ = search_toggle;
#line 95 "../src/Widgets/Sidebar.vala"
	_tmp37_ = _data1_->search_revealer;
#line 95 "../src/Widgets/Sidebar.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp36_, "active", (GObject*) _tmp37_, "reveal-child", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 97 "../src/Widgets/Sidebar.vala"
	_tmp38_ = _data1_->search_revealer;
#line 97 "../src/Widgets/Sidebar.vala"
	g_signal_connect_data ((GObject*) _tmp38_, "notify::child-revealed", (GCallback) __widgets_sidebar___lambda6__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 105 "../src/Widgets/Sidebar.vala"
	_tmp39_ = notifications_plug_notify_settings;
#line 105 "../src/Widgets/Sidebar.vala"
	_tmp40_ = do_not_disturb_switch;
#line 105 "../src/Widgets/Sidebar.vala"
	g_settings_bind (_tmp39_, "do-not-disturb", (GObject*) _tmp40_, "active", G_SETTINGS_BIND_DEFAULT);
#line 112 "../src/Widgets/Sidebar.vala"
	_tmp41_ = backend_notify_manager_get_default ();
#line 112 "../src/Widgets/Sidebar.vala"
	_tmp42_ = backend_notify_manager_get_apps (_tmp41_);
#line 112 "../src/Widgets/Sidebar.vala"
	_tmp43_ = _tmp42_;
#line 112 "../src/Widgets/Sidebar.vala"
	gee_abstract_map_foreach ((GeeAbstractMap*) _tmp43_, __widgets_sidebar___lambda7__gee_forall_func, _data1_);
#line 119 "../src/Widgets/Sidebar.vala"
	_tmp44_ = _data1_->app_list;
#line 119 "../src/Widgets/Sidebar.vala"
	_tmp45_ = gtk_widget_get_first_child ((GtkWidget*) _tmp44_);
#line 119 "../src/Widgets/Sidebar.vala"
	if (_tmp45_ != NULL) {
#line 903 "Sidebar.c"
		GtkListBoxRow* row = NULL;
		GtkListBox* _tmp46_;
		GtkWidget* _tmp47_;
		GtkListBoxRow* _tmp48_;
		GtkListBox* _tmp49_;
		GtkListBoxRow* _tmp50_;
		GtkListBoxRow* _tmp51_;
#line 120 "../src/Widgets/Sidebar.vala"
		_tmp46_ = _data1_->app_list;
#line 120 "../src/Widgets/Sidebar.vala"
		_tmp47_ = gtk_widget_get_first_child ((GtkWidget*) _tmp46_);
#line 120 "../src/Widgets/Sidebar.vala"
		_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 120 "../src/Widgets/Sidebar.vala"
		row = _tmp48_;
#line 122 "../src/Widgets/Sidebar.vala"
		_tmp49_ = _data1_->app_list;
#line 122 "../src/Widgets/Sidebar.vala"
		_tmp50_ = row;
#line 122 "../src/Widgets/Sidebar.vala"
		gtk_list_box_select_row (_tmp49_, _tmp50_);
#line 123 "../src/Widgets/Sidebar.vala"
		_tmp51_ = row;
#line 123 "../src/Widgets/Sidebar.vala"
		widgets_sidebar_show_row (self, _tmp51_);
#line 119 "../src/Widgets/Sidebar.vala"
		_g_object_unref0 (row);
#line 931 "Sidebar.c"
	}
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (toolbarview);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (footer);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (do_not_disturb_switch);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (do_not_disturb_label);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (scrolled_window);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (headerbar);
#line 29 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (search_toggle);
#line 29 "../src/Widgets/Sidebar.vala"
	block1_data_unref (_data1_);
#line 29 "../src/Widgets/Sidebar.vala"
	_data1_ = NULL;
#line 29 "../src/Widgets/Sidebar.vala"
	return obj;
#line 953 "Sidebar.c"
}

static void
widgets_sidebar_base_init (WidgetsSidebarClass * klass)
{
#line 26 "../src/Widgets/Sidebar.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "settingssidebar");
#line 961 "Sidebar.c"
}

static void
widgets_sidebar_class_init (WidgetsSidebarClass * klass,
                            gpointer klass_data)
{
#line 20 "../src/Widgets/Sidebar.vala"
	widgets_sidebar_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/Sidebar.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsSidebar_private_offset);
#line 20 "../src/Widgets/Sidebar.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_sidebar_constructor;
#line 20 "../src/Widgets/Sidebar.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_sidebar_finalize;
#line 976 "Sidebar.c"
}

static void
widgets_sidebar_instance_init (WidgetsSidebar * self,
                               gpointer klass)
{
#line 20 "../src/Widgets/Sidebar.vala"
	self->priv = widgets_sidebar_get_instance_private (self);
#line 985 "Sidebar.c"
}

static void
widgets_sidebar_finalize (GObject * obj)
{
	WidgetsSidebar * self;
#line 20 "../src/Widgets/Sidebar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SIDEBAR, WidgetsSidebar);
#line 23 "../src/Widgets/Sidebar.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 20 "../src/Widgets/Sidebar.vala"
	G_OBJECT_CLASS (widgets_sidebar_parent_class)->finalize (obj);
#line 998 "Sidebar.c"
}

static GType
widgets_sidebar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsSidebarClass), (GBaseInitFunc) widgets_sidebar_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_sidebar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsSidebar), 0, (GInstanceInitFunc) widgets_sidebar_instance_init, NULL };
	GType widgets_sidebar_type_id;
	widgets_sidebar_type_id = g_type_register_static (gtk_box_get_type (), "WidgetsSidebar", &g_define_type_info, 0);
	WidgetsSidebar_private_offset = g_type_add_instance_private (widgets_sidebar_type_id, sizeof (WidgetsSidebarPrivate));
	return widgets_sidebar_type_id;
}

GType
widgets_sidebar_get_type (void)
{
	static volatile gsize widgets_sidebar_type_id__once = 0;
	if (g_once_init_enter (&widgets_sidebar_type_id__once)) {
		GType widgets_sidebar_type_id;
		widgets_sidebar_type_id = widgets_sidebar_get_type_once ();
		g_once_init_leave (&widgets_sidebar_type_id__once, widgets_sidebar_type_id);
	}
	return widgets_sidebar_type_id__once;
}

